/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:44:02 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.appstate.model;

/**
 * This is a JSON template for an app state write result.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google App State API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class WriteResult extends com.google.api.client.json.GenericJson {

  /**
   * The version of the data for this key on the server.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String currentStateVersion;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * appstate#writeResult.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The written key.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Integer stateKey;

  /**
   * The version of the data for this key on the server.
   * @return value or {@code null} for none
   */
  public java.lang.String getCurrentStateVersion() {
    return currentStateVersion;
  }

  /**
   * The version of the data for this key on the server.
   * @param currentStateVersion currentStateVersion or {@code null} for none
   */
  public WriteResult setCurrentStateVersion(java.lang.String currentStateVersion) {
    this.currentStateVersion = currentStateVersion;
    return this;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * appstate#writeResult.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * appstate#writeResult.
   * @param kind kind or {@code null} for none
   */
  public WriteResult setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The written key.
   * @return value or {@code null} for none
   */
  public java.lang.Integer getStateKey() {
    return stateKey;
  }

  /**
   * The written key.
   * @param stateKey stateKey or {@code null} for none
   */
  public WriteResult setStateKey(java.lang.Integer stateKey) {
    this.stateKey = stateKey;
    return this;
  }

  @Override
  public WriteResult set(String fieldName, Object value) {
    return (WriteResult) super.set(fieldName, value);
  }

  @Override
  public WriteResult clone() {
    return (WriteResult) super.clone();
  }

}
